/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using MeshVR;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using System.Linq;using UnityEngine.UI;namespace PluginIdea.Matcap{public class MatInfo{public Renderer renderer;public Material originMat;public Material actualMat;}public class Matcap : MVRScript{private const string MATCAP_SHADER = "PluginIdea/MatcapSpec";private const string DEFAULT_ASSET_PATH = "Custom/Assets/MyAssets";private TextureSettings abedoTextureSetting = new TextureSettings(){compress = true, linearColor = false};private Dictionary<string, Shader> dic_BundleShaders = new Dictionary<string, Shader>();private Dictionary<string, MatInfo> dic_Mats = new Dictionary<string, MatInfo>();private JSONStorableColor mainColor;private JSONStorableFloat alpha;private JSONStorableUrl mainTexUrl;private JSONStorableUrl bumpMapUrl;private JSONStorableFloat bumpMapScale;private JSONStorableFloat bumpMapTileMount;private JSONStorableUrl matcapDiffuseUrl;private JSONStorableFloat matcapDiffuseScale;private JSONStorableUrl matcapSpecUrl;private JSONStorableFloat matcapSpecScale;private JSONStorableStringChooser materialsChooser;private UIDynamicButton ResetBtn;private List<string> materialStrs = new List<string>();private bool isExternalResourcesLoaded;private bool IsExternalResourcesLoaded{get{return this.isExternalResourcesLoaded;}}private MatInfo currentMatInfo;private MatInfo CurrentMatInfo{get{return currentMatInfo;}}private Request request;private void ResourceInit(){string assetsBundlePath = Utils.GetPluginPath(this) + string.Format("/resources/matcap{0}.assetbundle", Utils.version);request = new Request{path = assetsBundlePath, callback = OnAssetBundleLoaded};AssetLoader.QueueLoadAssetBundleFromFile(request);}private void OnAssetBundleLoaded(Request request){Shader[] shaders = request.assetBundle.LoadAllAssets<Shader>();for (int i = 0;i < shaders.Length;i++){SuperController.LogMessage("Shader: " + shaders[i].name);if (!dic_BundleShaders.ContainsKey(shaders[i].name)){dic_BundleShaders.Add(shaders[i].name, shaders[i]);}}isExternalResourcesLoaded = true;DelayInit();}private Button hardResetBtn;private void RegistBundleUnload(){hardResetBtn = SuperController.singleton.mainHUD.Find("MainUICanvas/Panel/Content/TabFile/Content/Hard Reset Button").GetComponent<Button>();hardResetBtn.onClick.AddListener(UnloadBundle);}private void UnloadBundle(){if (request.assetBundle != null){request.assetBundle.Unload(false);}}public override void Init(){Location.InitTData();ResourceInit();RegistBundleUnload();Utils.InitUI(CreateUIElement);var btn = Utils.CreateButton(this, Location.GetStr(Location.OpenMainPage), () =>{if (Location.IsChinease) Application.OpenURL(@"https:\/\/afdian.net/p/6f6685ceae9211ed8c8952540025c377");else Application.OpenURL(@"https:\/\/www.patreon.com/PluginIdea/about");}, false, true);btn.buttonImage.color = Color.yellow;materialsChooser = Utils.CreateStringChooser(this, Location.GetStr(Location.SelfMaterials), new List<string>(), 0, false, true);materialsChooser.setCallbackFunction = (val) =>{if (string.IsNullOrEmpty(val) || !IsExternalResourcesLoaded) return;MatInfo matInfo = dic_Mats[val];RecoverLast();matInfo.actualMat.shader = dic_BundleShaders[MATCAP_SHADER];matInfo.renderer.material = matInfo.actualMat;currentMatInfo = matInfo;};ResetBtn = Utils.CreateButton(this, Location.GetStr(Location.ResetMaterials), () =>{string matName = materialsChooser.val;if (dic_Mats.ContainsKey(matName)){MatInfo matInfo = dic_Mats[matName];matInfo.renderer.material = matInfo.originMat;}}, false, true);Utils.CreateSpacer(this, 40, true);mainColor = Utils.CreateColor(this, Location.GetStr(Location.MainColor), Color.white, true);mainColor.setCallbackFunction = (h, s, v) =>{if (!IsExternalResourcesLoaded || currentMatInfo == null) return;CurrentMatInfo.renderer.material.SetColor("_Color", Color.HSVToRGB(h, s, v));};alpha = Utils.CreateSliderFloat(this, Location.GetStr(Location.Alpha), 1, 0, 1, false, true);alpha.setCallbackFunction = (val) =>{if (!IsExternalResourcesLoaded || currentMatInfo == null) return;CurrentMatInfo.renderer.material.SetFloat("_Alpha", val);};Utils.CreateSpacer(this, 20, false);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.AbedoSubtitle), 35, false);mainTexUrl = Utils.CreateTexture2DChooser(this, Location.GetStr(Location.MainTexture), DEFAULT_ASSET_PATH, false, abedoTextureSetting, (tex) =>{if (!IsExternalResourcesLoaded || currentMatInfo == null) return;CurrentMatInfo.renderer.material.SetTexture("_MainTex", tex);}, true);Utils.CreateTwinButton(this, Location.GetStr(Location.ReloadTex), () =>{mainTexUrl.Reload();}, Location.GetStr(Location.DestroyTex), () =>{mainTexUrl.ClearVal();Texture obj = CurrentMatInfo.renderer.material.GetTexture("_MainTex");Destroy(obj);}, false, true);Utils.CreateSpacer(this, 20, true);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.BumpSubtitle), 35, true);bumpMapUrl = Utils.CreateTexture2DChooser(this, Location.GetStr(Location.BumpMap), DEFAULT_ASSET_PATH, true, abedoTextureSetting, (tex) =>{if (!IsExternalResourcesLoaded || currentMatInfo == null) return;CurrentMatInfo.renderer.material.SetTexture("_BumpMap", tex);}, true);bumpMapScale = Utils.CreateSliderFloat(this, Location.GetStr(Location.BumpScale), 1, 0, 5, true, true);bumpMapScale.setCallbackFunction = (val) =>{if (!IsExternalResourcesLoaded || currentMatInfo == null) return;CurrentMatInfo.renderer.material.SetFloat("_BumpValue", val);};bumpMapTileMount = Utils.CreateSliderFloat(this, Location.GetStr(Location.BumpTileMount), 1, 0, 10, true, true);bumpMapTileMount.setCallbackFunction = (val) =>{if (!IsExternalResourcesLoaded || currentMatInfo == null) return;CurrentMatInfo.renderer.material.SetFloat("_BumpTileMount", val);};Utils.CreateTwinButton(this, Location.GetStr(Location.ReloadTex), () =>{bumpMapUrl.Reload();}, Location.GetStr(Location.DestroyTex), () =>{bumpMapUrl.ClearVal();Destroy(CurrentMatInfo.renderer.material.GetTexture("_BumpMap"));}, true, true);Utils.CreateSpacer(this, 20, false);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.MatcapDiffuseSubtitle), 35, false);matcapDiffuseUrl = Utils.CreateTexture2DChooser(this, Location.GetStr(Location.MatcapDiffuse), DEFAULT_ASSET_PATH, false, abedoTextureSetting, (tex) =>{if (!IsExternalResourcesLoaded || currentMatInfo == null) return;CurrentMatInfo.renderer.material.SetTexture("_MatCapDiffuse", tex);}, true);matcapDiffuseScale = Utils.CreateSliderFloat(this, Location.GetStr(Location.MatcapDiffuseScale), 1, 0, 1, false, true);matcapDiffuseScale.setCallbackFunction = (val) =>{if (!IsExternalResourcesLoaded || currentMatInfo == null) return;CurrentMatInfo.renderer.material.SetFloat("_DiffuseValue", val);};Utils.CreateTwinButton(this, Location.GetStr(Location.ReloadTex), () =>{matcapDiffuseUrl.Reload();}, Location.GetStr(Location.DestroyTex), () =>{matcapDiffuseUrl.ClearVal();}, false, true);Utils.CreateSpacer(this, 20, true);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.MatcapSpecSubtitle), 35, true);matcapSpecUrl = Utils.CreateTexture2DChooser(this, Location.GetStr(Location.MatcapSpecMap), DEFAULT_ASSET_PATH, true, abedoTextureSetting, (tex) =>{if (!IsExternalResourcesLoaded || currentMatInfo == null) return;CurrentMatInfo.renderer.material.SetTexture("_MatCapSpec", tex);}, true);matcapSpecScale = Utils.CreateSliderFloat(this, Location.GetStr(Location.MatcapSpecScale), 1, 0, 5, true, true);matcapSpecScale.setCallbackFunction = (val) =>{if (!IsExternalResourcesLoaded || currentMatInfo == null) return;CurrentMatInfo.renderer.material.SetFloat("_SpecValue", val);};Utils.CreateTwinButton(this, Location.GetStr(Location.ReloadTex), () =>{matcapSpecUrl.Reload();}, Location.GetStr(Location.DestroyTex), () =>{matcapSpecUrl.ClearVal();}, true, true);}private void RecoverLast(){if (currentMatInfo != null){currentMatInfo.renderer.material = currentMatInfo.originMat;}}private void DelayInit(){RefreshAtomCustomColorUI();if (IsValidPath(materialsChooser.val)) materialsChooser.setCallbackFunction(materialsChooser.val);mainColor.setCallbackFunction(mainColor.val.H, mainColor.val.S, mainColor.val.V);if (IsValidPath(mainTexUrl.val)) mainTexUrl.Reload();if (IsValidPath(bumpMapUrl.val)) bumpMapUrl.Reload();if (IsValidPath(matcapDiffuseUrl.val)) matcapDiffuseUrl.Reload();if (IsValidPath(matcapSpecUrl.val)) matcapSpecUrl.Reload();alpha.setCallbackFunction(alpha.val);bumpMapTileMount.setCallbackFunction(bumpMapTileMount.val);bumpMapScale.setCallbackFunction(bumpMapScale.val);matcapDiffuseScale.setCallbackFunction(matcapDiffuseScale.val);matcapSpecScale.setCallbackFunction(matcapSpecScale.val);}private bool IsValidPath(string path){return !string.IsNullOrEmpty(path) && path != DEFAULT_ASSET_PATH;}private void RefreshAtomCustomColorUI(){dic_Mats.Clear();materialStrs.Clear();Renderer[] renders = containingAtom.reParentObject.GetComponentsInChildren<Renderer>(true);if (renders.Length > 0){renders.ToList().ForEach(rd =>{Material tmpMat = rd.material;if (!dic_Mats.ContainsKey(tmpMat.name)){MatInfo mi = new MatInfo(){originMat = tmpMat,                            actualMat = new Material(tmpMat),                            renderer = rd};dic_Mats.Add(tmpMat.name, mi);materialStrs.Add(tmpMat.name);}});}SuperController.LogMessage(materialStrs.Count.ToString());if (materialStrs.Count > 0){materialsChooser.choices = new List<string>();materialsChooser.choices = materialStrs;}}private void OnDestroy(){Utils.DestroyUI();RecoverLast();if (hardResetBtn != null){hardResetBtn.onClick.RemoveListener(UnloadBundle);}}}}